﻿local L = LibStub("AceLocale-3.0"):GetLocale("GigaItemAuction", false)

local _G				= getfenv(0)

local pairs				= _G.pairs
local ipairs			= _G.ipairs
local select			= _G.select

local table_insert		= _G.table.insert
local table_remove		= _G.table.remove
local table_sort		= _G.table.sort

local PLAYERNAME		= UnitName("player")
local _, PLAYERCLASS	= UnitClass("player")
local PLAYERGUID		= false

local db

local falseVersionMSG	= false


function GigaItemAuction:SYNCOnInitialize()
	db = self.db.profile
	self:RegisterComm(self.amsg.prefix, "OnCommReceive")
end

local function splitMessage(msg)
	return strsplit(" ",msg)
end

function GigaItemAuction:OnCommReceive(prefix, value, typ, author)
	if prefix ~= self.amsg.prefix then return end
	if typ ~= "GUILD" and typ ~= "RAID" and typ ~= "WHISPER" then return end
	
	PLAYERGUID = PLAYERGUID or self:getMyGUID()
	
	local worked, key	= self:Deserialize(value)
	local addonMSG		= self.amsg.key
	
	local cauthor = self:GetColoredName(author)
	
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
	
	if not worked then
		local broken_key, broken_value = splitMessage(value)
		if broken_key ~= addonMSG.revision then
			if dbc.debugmodus then
				self:Print(L["syncerror1"]:format(cauthor))
			else
				self:Debug(L["syncerror1"]:format(cauthor))
			end
		end
		return
	end
	
	
	if typ == "GUILD" or typ == "RAID" then
	
--~ Gebot kommt an
		if key == addonMSG.sendtruebid then	
			
			if dbc.debugmodus then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Bid true. ["..cauthor.."]")
			else
				self:Debug("|cff5555ffSYNC %s:|r INC - Bid true. [%s]",typ,cauthor)
			end
			
			self:NewBidAuction(value, author)
--~ Versteigerung beendet
		elseif key == addonMSG.sendendauction then
			
			if dbc.debugmodus then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Auction end. ["..cauthor.."]")
			else
				self:Debug("|cff5555ffSYNC %s:|r INC - Auction end. [%s]",typ,cauthor)
			end
			
			self:StopAuction(value, author)
--~ Versteigerung abgebrochen
		elseif key == addonMSG.breakauction then
			
			if dbc.debugmodus then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Auction break. ["..cauthor.."]")
			else
				self:Debug("|cff5555ffSYNC %s:|r INC - Auction break. [%s]",typ,cauthor)
			end
			
			self.auctionAdminBreak = author
			self:StopAuction(self.auctionAdminBreak, author)
--~ Versteigerung verlängern
		elseif key == addonMSG.auctionlong then
			if dbc.debugmodus then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Current auction bidtime edit. ["..cauthor.."]")
			else
				self:Debug("|cff5555ffSYNC %s:|r INC - Current auction bidtime edit. [%s]",typ,cauthor)
			end
			
			self:AdminAuctionLonger(author) 
			
--~ Versteigerungszeit geaendert
		elseif key == addonMSG.newbidtime then
			if dbc.debugmodus then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Edit bidtime by ["..cauthor.."]")
			else
				self:Debug("|cff5555ffSYNC %s:|r INC - Edit bidtime by [%s]",typ,cauthor)
			end
			
			self:AdminEditBidTimeByAdmin(value, author)
			
--~ Raid version check
		elseif key == addonMSG.sendversioncheck then
			
			local guildSum, raidSum = self:CheckRulesSum()
			self:SendAddonMSG(self:Serialize(addonMSG.getversioncheck, self.revision, PLAYERCLASS, PLAYERNAME, self:CheckSecurity(PLAYERNAME, 'admin'), dba.bidTime, guildSum, raidSum), "WHISPER", author)
			
			if dbc.debugmodus then
				self:Print("|cff5555ffDEBUG "..typ..":|r SEND - My version send to ["..cauthor.."].")
			else
				self:Debug("|cff5555ffSYNC %s:|r SEND - My version send to [%s]",typ,cauthor)
			end
			
--~ Version testing
		elseif key == addonMSG.revision then
			_, _, value = self:Deserialize(value)
			
			if tonumber(value) > tonumber(self.revision) and tonumber(value) > tonumber(self.revisionNEW) then
				self.AUCTIONFrame.Title:SetText("|cffff0000"..L["NEW"].."|r |cffffffffr"..value.."|r")
				self.revisionNEW = tonumber(value)
				if not falseVersionMSG then
					self:Print(L["hinweis4"])
					falseVersionMSG = true
				end
			else
				self.AUCTIONFrame.Title:SetText("")
			end
			
			if dbc.debugmodus then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - ["..cauthor.."] send version. r"..value)
			else
				self:Debug("|cff5555ffSYNC %s:|r INC - [%s] send version. r%s",typ,cauthor,value)
			end
			
--~ Start Auction
		elseif key == addonMSG.sendstartauction then
			if dbc.debugmodus then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Auction started by ["..cauthor.."].")
			else
				self:Debug("|cff5555ffSYNC %s:|r INC - Auction started by [%s]",typ,cauthor)
			end
			
			self:PauseStartAuction(author, true)
			
--~ Pause Auction
		elseif key == addonMSG.sendpauseauction then
			if dbc.debugmodus then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Auction paused by ["..cauthor.."].")
			else
				self:Debug("|cff5555ffSYNC %s:|r INC - Auction paused by [%s]",typ,cauthor)
			end
			
			self:PauseStartAuction(author, false)
			
--~ Reset Auction
		elseif key == addonMSG.sendresetauction then
			if dbc.debugmodus then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Auction reset by ["..cauthor.."].")
			else
				self:Debug("|cff5555ffSYNC %s:|r INC - Auction reset by [%s]",typ,cauthor)
			end
			
			self:ResetAuction(author)
-----------------------------------------------------------
--~ OPTIONS SETTINGS			
--~ Withdraw option
		elseif key == addonMSG.sendwithdraw then
			_, _, value = self:Deserialize(value)
			dba.bidWithdraw = value
			
			if dbc.debugmodus then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Bid withdraw mode edit by ["..cauthor.."]. Value: "..(value and 'approve' or 'block'))
			else
				self:Debug("|cff5555ffSYNC %s:|r INC - Bid withdraw mode edit by [%s]. Value:%s",typ,cauthor,(value and 'approve' or 'block'))
			end
			
			self:SetBreakButtonUpdate()
			
--~ Highest bidder option
		elseif key == addonMSG.sendanonym then
			_, _, value = self:Deserialize(value)
			dba.bidderShow = value
			
			if dbc.debugmodus then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Highest bidder showmode edit by ["..cauthor.."]. Value: "..(value and 'visible' or 'anonym'))
			else
				self:Debug("|cff5555ffSYNC %s:|r INC - Highest bidder showmode edit by [%s]. Value:%s",typ,cauthor,(value and 'visible' or 'anonym'))
			end
			
--~ Guild/Raid Rules Sync
		elseif key == addonMSG.sendguildrules then
			if dbc.debugmodus then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Guild/Raid Rules Sync by ["..cauthor.."].")
			else
				self:Debug("|cff5555ffSYNC %s:|r INC - Guild/Raid Rules Sync by [%s]",typ,cauthor)
			end
			
			self:AdminCurrentGuildRulesSync(value, author)
			
--~ Admin Option Edition
		elseif key == addonMSG.sendeditoption then	
			local _, _, db_key, db_value, db_sub = self:Deserialize(value)
			
			if not db_key and (not db_value or type(db_value) ~= "boolean") then return end
			
			if db_key == 'bidStep' then
				dba.oldBitStep = dba.bidStep
			end
			
			if db_optional then
				dba[db_sub][db_key] = db_value and db_value or false
			else
				dba[db_key] = db_value and db_value or false
			end
			
			if dbc.debugmodus then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Adminoption edit by ["..cauthor.."]. "..
				"Key: "..(db_optional and (db_sub..'.') or '')..(db_key and db_key or 'undefine')..", "..
				"Value: "..(type(db_value) == "boolean" and (db_value and 'true' or 'false') or (db_value and db_value or 'false')))
			else
				self:Debug("|cff5555ffSYNC %s:|r INC - Adminoption edit by [%s]. Key:%s, Value:%s",
					typ, cauthor,
					(db_optional and (db_sub..'.') or '')..(db_key and db_key or 'undefine'),
					(type(db_value) == "boolean" and (db_value and 'true' or 'false') or (db_value and db_value or 'false'))
				)
			end
			
			self:SyncButtonsWithDatabase()
			
-----------------------------------------------------------
--~ Error incoming
		elseif key == addonMSG.sendfalsebid then
			if dbc.debugmodus then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Error-/Hintreport by ["..cauthor.."].")
			else
				self:Debug("|cff5555ffSYNC %s:|r INC - Error-/Hintreport by [%s]",typ,cauthor)
			end
			
			_, _, value = self:Deserialize(value)
			self:FalseBidAuction(value, author)
			
--~ Wenn Bietzeit anders ist, dann aktuallisieren
		elseif key == addonMSG.sendbidtime then
			if dbc.debugmodus then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Response current Auction from ["..cauthor.."].")
			else
				self:Debug("|cff5555ffSYNC %s:|r INC - Response current Auction from [%s]",typ,cauthor)
			end
			
			self:AdminCurrentAuctionSync(value, author)
			
			
		end
		
		
		
	elseif typ == "WHISPER" then
--~ Raid version incoming
		if key == addonMSG.getversioncheck then
			self:VersionShowAll(value)
			
--~ Wenn Bietzeit anders ist, dann aktuallisieren
		elseif key == addonMSG.sendbidtime then
			if dbc.debugmodus then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Response current Auction from ["..cauthor.."].")
			else
				self:Debug("|cff5555ffSYNC %s:|r INC - Response current Auction from [%s]",typ,cauthor)
			end
			
			self:AdminCurrentAuctionSync(value, author)
			
--~ Author wird nach Bietzeit gefragt
		elseif key == addonMSG.getbidtime and self:CheckSecurity(PLAYERNAME, 'auctioneer') then
			if dbc.debugmodus then
				self:Print("|cff5555ffDEBUG "..typ..":|r SEND - Send interpellate for Bidtime to ["..cauthor.."].")
			else
				self:Debug("|cff5555ffSYNC %s:|r SEND - Send interpellate for Bidtime to [%s]",typ,cauthor)
			end
			self:AdminCurrentRulesSend(author, typ)
			self:AdminCurrentAuctionSend(author, typ)
			
--~ Gebot von Player kommt rein
		elseif key == addonMSG.bidpoint then
			if dbc.debugmodus then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Bid from ["..cauthor.."] incomig.")
			else
				self:Debug("|cff5555ffSYNC %s:|r INC - Bid from [%s] incomig.",typ,cauthor)
			end
			
			self:IncomingNewBid(value, author)
			
--~ Pass von Player kommt rein
		elseif key == addonMSG.sendpassbid then
			if dbc.debugmodus then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Bid for ["..cauthor.."] withdraw.")
			else
				self:Debug("|cff5555ffSYNC %s:|r INC - Bid for [%s] withdraw.",typ,cauthor)
			end
			
			self:IncomingPassLastBid(value, author)
			
--~ VersteigerungsDatenVergleich incoming
		elseif key == addonMSG.sendauctiondata then
			if dbc.debugmodus then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - AuctionData from ["..cauthor.."] incomig.")
			else
				self:Debug("|cff5555ffSYNC %s:|r INC - AuctionData from [%s] incomig.",typ,cauthor)
			end
			
			self:IncomingAuctionDATA(value, author)
			
--~ VersteigerungsDatenVergleich send
		elseif key == addonMSG.getauctiondata then
			if dbc.debugmodus then
				self:Print("|cff5555ffDEBUG "..typ..":|r SEND - AuctionData from ["..cauthor.."] submitted and to you send.")
			else
				self:Debug("|cff5555ffSYNC %s:|r SEND - AuctionData from [%s] submitted and to you send.",typ,cauthor)
			end
			
			if self.auctionStatusSTART then
				local auctionDATA = self:Serialize(addonMSG.sendauctiondata, dbn.itemID, dbn.auctionAuthor, dbn.channel, dbn.last.bidderGUID, dbn.last.BidPoint, dbn.last.BidTime, dbn.last.BidArt, dbn.last.BidU80, (dba.bidderShow and false or dbn.last.IsName), dbn.minimumBid)
				self:SendAddonMSG(auctionDATA, "WHISPER", author)
			end
			
--~ Fehlgebot incoming
		elseif key == addonMSG.sendfalsebid then
			if dbc.debugmodus then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Errorreport from ["..cauthor.."] incoming.")
			else
				self:Debug("|cff5555ffSYNC %s:|r INC - Errorreport from [%s] incoming.",typ,cauthor)
			end
			
			_, _, value = self:Deserialize(value)
			self:FalseBidAuction(value, author)
			
--~ Guild/Raid Rules Sync
		elseif key == addonMSG.sendguildrules then
			if dbc.debugmodus then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Guild/Raid Rules Sync by ["..cauthor.."].")
			else
				self:Debug("|cff5555ffSYNC %s:|r INC - Guild/Raid Rules Sync by [%s]",typ,cauthor)
			end
			
			self:AdminCurrentGuildRulesSync(value, author)
			
		end
	end
end


---------------------------------------
--~ SendMessages
---------------------------------------
function GigaItemAuction:SendAddonMSG(serialdata, channel, player)
	local dbn = db.nowAuction
	local channel = channel or dbn.channel
	local channels = {["RAID"]=true,["GUILD"]=true,["WHISPER"]=true}
	local player = player or dbn.auctionAuthor or nil
	if not channels[channel] then self:Print("|cffff5555ERROR:|r SendCommMessage: setChannel") return end
	
	self:SendCommMessage(self.amsg.prefix, serialdata, channel, channel == "WHISPER" and player or nil)
end

function GigaItemAuction:Whisper(player, text, noprefix)
	local PreText = noprefix and "" or "GIA: "
	local msg = ""
	if player and text then
		msg = PreText..text
		sentWhispers[msg] = true
		SendChatMessage(msg, "WHISPER", GetLanguageByIndex(0), player)
	end
end


---------------------------------------

function GigaItemAuction:SyncGuildRankWithDatabase()
	local dbg = db.auctionSecurity.guildRank
	local nameRank = ''
	local numRanks = GuildControlGetNumRanks()
	local j = 1
	for i = 1, numRanks, 1 do
		dbg["rank"..i].name = GuildControlGetRankName(i)
		j = j + 1
	end
	if j < 10 then
		for k = j, 10, 1 do
			dbg["rank"..k].name = "rank"..k
		end
	end
	
	self:Debug("%sWithDatabase","SyncGuildRank")
	
	if IsInGuild() and dbg.rank1.name == "rank1" then
		self:GIATimerStart("SyncGuildRankWithDatabase","SyncGuildRankWithDatabase",4)
	end
end

-----------------------------------------


function GigaItemAuction:SyncBidArt()
	local dba = db.admin
	local s = {}
	s.kurz, s.lang = L["u80_mini"]:format(dba.bidUP), L["u80"]:format(dba.bidUP)
	self.BidArt = {
		kurz = {"M","S","F",s.kurz},
		lang = {L["admin_option_bidArt_main"], L["admin_option_bidArt_second"], L["admin_option_bidArt_fun"], s.lang},
		kula = {
			["M"] = L["admin_option_bidArt_main"], 
			["S"] = L["admin_option_bidArt_second"], 
			["F"] = L["admin_option_bidArt_fun"], 
			[s.kurz] = s.lang,
		}
	}
end

function GigaItemAuction:SyncButtonsWithDatabase()
	local f = self.AUCTIONFrame
	local a = self.ADMINFrame
    local t = self.BidArt
	
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
	
	self:SyncBidArt()
	
	if dba.bidArt.main then
		f.Radio[1]:Enable()
		f.RadioText[1]:SetTextColor(unpack(self.colors.white))
	else
		f.Radio[1]:Disable()
		f.RadioText[1]:SetTextColor(unpack(self.colors.neutral))
	end
	
	if dba.bidArt.second then
		f.Radio[2]:Enable()
		f.RadioText[2]:SetTextColor(unpack(self.colors.white))
	else
		f.Radio[2]:Disable()
		f.RadioText[2]:SetTextColor(unpack(self.colors.neutral))
	end
	
	if dba.bidArt.fun then
		f.Radio[3]:Enable()
		f.RadioText[3]:SetTextColor(unpack(self.colors.white))
	else
		f.Radio[3]:Disable()
		f.RadioText[3]:SetTextColor(unpack(self.colors.neutral))
	end
	
	if dba.bidArt.u80 then
		f.CheckU80:Enable()
		f.CheckU80Text:SetTextColor(unpack(self.colors.white))
	else
		f.CheckU80:Disable()
		f.CheckU80Text:SetTextColor(unpack(self.colors.neutral))
		
		dbc.bidU80 = false
		f.CheckU80:SetChecked(dbc.bidU80 and true or false)
	end
	f.CheckU80Text:SetText(t.kurz[4])
	f.CheckU80:SetScript("OnEnter", function(self)
		GameTooltip:SetOwner(this, "ANCHOR_TOPLEFT");
		GameTooltip:AddLine(t.lang[4])
		GameTooltip:Show()
	end)
	
	if dba.bidWithdraw then
		a.RadioWithdraw[1]:SetChecked(true)
		a.RadioWithdraw[2]:SetChecked(false)
	else
		a.RadioWithdraw[1]:SetChecked(false)
		a.RadioWithdraw[2]:SetChecked(true)
	end
	
	if dba.bidderShow then
		a.RadioHighestBidder[1]:SetChecked(false)
		a.RadioHighestBidder[2]:SetChecked(true)
	else
		a.RadioHighestBidder[1]:SetChecked(true)
		a.RadioHighestBidder[2]:SetChecked(false)
	end
	
	if dba.oldBidStep ~= dba.bidStep then
		local s1f, s2f, s3f, s4f = dbc.bidStep.step1/dba.oldBidStep, dbc.bidStep.step2/dba.oldBidStep, dbc.bidStep.step3/dba.oldBidStep, dbc.bidStep.step4/dba.oldBidStep
		
		dbc.bidStep.step1 = ceil(dba.bidStep * s1f)
		dbc.bidStep.step2 = ceil(dba.bidStep * s2f)
		dbc.bidStep.step3 = ceil(dba.bidStep * s3f)
		dbc.bidStep.step4 = ceil(dba.bidStep * s4f)
		dba.oldBidStep = dba.bidStep
	end
	
	self:SetAuctionBidStats()
	
	a.timeSlider:SetValue(dba.bidTime)
end